/*
 * BMG.H - Searching functions
 *
 * Msged/Q message editor for QuickBBS  Copyright 1990 by P.J. Muller
 *
 */

/*
 *	bmg.h ->	Boyer-Moore-Gosper search definitions
 *
 *	see bmg.c for documentation
 */

#define	bmgMAXPAT	64		/*  max pattern length	*/

typedef struct
	{
#ifdef BMGSEARCH
	char	delta[256];		/*  ASCII only deltas	*/
#endif
	char	pat[bmgMAXPAT + 1];	/*  the pattern		*/
	char	ignore;			/*  ignore case flag	*/
	}
	bmgARG;

void bmgCompile(char *s, bmgARG *pattern, int ignore_case);
int bmgSearch(char *buffer, int buflen, bmgARG *pattern);

/*
 *	END of bmg.h
 */
