/*
 * MAINCMDS.H - Reading command tables
 *
 * Msged/Q message editor for QuickBBS  Copyright 1990 by P.J. Muller
 *
 */

void	left(void);
void	right(void);
void	enter(void);
void	movetop(void);
void	movebot(void);
void	marklast(void);
void	srchhdr(void);
void	quotemv(void);
void	nextarea(void);
void	prevarea(void);
void	uparea(void);
void	downarea(void);
void	nextto(void);
void	escquit(void);
void	newarea(void);
void	go_last(void);
void	link_to(void);
void	link_from(void);
void	view(void);
void	go_root(void);
void	go_dos(void);
void	search(void);
void	deletemsg(void);			/* maintmsg.c	*/
void 	newmsg(void);                   	/* makemsg.c	*/
void 	reply(void);				/* makemsg.c	*/
void 	quote(void);				/* makemsg.c	*/
void	movemsg(void);				/* maintmsg.c	*/
void	writetxt(void); 			/* textfile.c	*/
void    settings(void);                         /* settings.c   */
void    help(void);                             /* help.c       */
void    list(void);                             /* msglist.c    */
void	change(void);				/* makemsg.c	*/
void	rotate(void);				/* msged.c	*/
void	togaddr(void);
void	maintarea(void);			/* maintmsg.c	*/

#ifndef MAIN
extern void (*mainckeys[128])(void);
extern void (*mainakeys[128])(void);
extern struct _command maincmds[];
#else
void (*mainckeys[256])(void) =
{
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /*  0 */
	NULL,	NULL,	NULL,	NULL,	NULL,	enter, uparea,	NULL, /*  8 */
      downarea,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 10 */
	NULL,   NULL,	NULL, escquit,	NULL,	NULL,	NULL,	NULL, /* 18 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 20 */
	NULL,	NULL,	NULL, nextarea,	NULL, prevarea,	NULL, nextto, /* 28 */
	NULL,   NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 30 */
	NULL,	NULL,	NULL,	NULL,	rotate,	NULL,	rotate,	NULL, /* 38 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 40 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 48 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 50 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 58 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 60 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 68 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 70 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 78 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 80 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 88 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 90 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 98 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* A0 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* A8 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* B0 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* B8 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* C0 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* C8 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* D0 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* D8 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* E0 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* E8 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* F0 */
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL  /* F8 */
};

void (*mainakeys[256])(void) =
{
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /*  0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /*  8 */
quote,	writetxt,newmsg,reply, togaddr,	NULL,marklast,	NULL, /* 10 */
go_dos, NULL,	NULL,	NULL,	NULL,	NULL,	newarea,settings,/* 18 */
deletemsg,search,maintarea,help,NULL,	NULL,	list,	NULL, /* 20 */
NULL,	NULL,	NULL,	NULL, srchhdr,	cleanup,change, view, /* 28 */
NULL, quotemv,	movemsg,NULL, 	NULL,	NULL,	NULL,	NULL, /* 30 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 38 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	go_root, /* 40 */
NULL,	NULL,	NULL,	left,	NULL,	right,	NULL,	go_last, /* 48 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 50 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 58 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 60 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 68 */
NULL,	NULL,	NULL,	link_from,link_to,movetop,NULL,movebot, /* 70 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,  /* 78 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 80 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 88 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 90 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 98 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* A0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* A8 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* B0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* B8 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* C0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* C8 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* D0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* D8 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* E0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* E8 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* F0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL  /* F8 */
};

struct _command maincmds[] = {
	{"next",right}, 	{"previous",left},	{"areas",newarea},
	{"last",go_last},	{"link_to",link_to},	{"link_from",link_from},
	{"view",view},		{"home",go_root},	{"shell",go_dos},
	{"search",search},	{"delete",deletemsg},	{"newmsg",newmsg},
	{"reply",reply},	{"quote",quote},	{"move",movemsg},
	{"export",writetxt},	{"config",settings},	{"help",help},
	{"list",list},		{"change",change},	{"null",NULL},
	{"exit",cleanup},	{"first",movebot},	{"end",movetop},
	{"nxtarea",nextarea},	{"prvarea",prevarea},	{"lastread",marklast},
	{"uparea",uparea},	{"downarea",downarea},	{"maintarea",maintarea},
	{NULL,NULL}
};

#endif
