/*
 * NEDIT.H - Buffer structure
 *
 * Msged/Q message editor for QuickBBS  Copyright 1990 by P.J. Muller
 *
 */

typedef struct _line {
	char *text;             /* pointer to actual line text */
	unsigned int block:1;	/* this is in a block */
	unsigned int hide:1;	/* this is a hidden line */
	unsigned int quote:1;	/* this is a quoted line */
	int column;		/* if a block, starting column */
	struct _line *prev;     /* previous line in BUFFER */
	struct _line *next;     /* next line in BUFFER */
	} LINE;
	
/*
 * a BUFFER is simply a linked list of LINE
 */
 
typedef struct _buffer {
	LINE *first;		/* first line in buffer */
        LINE *last;         /* last line in buffer */
	} BUFFER;
