/*
 * SCREEN.H - Display functions
 *
 * Msged/Q message editor for QuickBBS  Copyright 1990 by P.J. Muller
 *
 */

#define DIRECT          0
#define BIOS            1
#define FOSSIL          2
#define NOSNOW		3

#ifdef WHITE
#undef WHITE
#endif

#ifdef BLACK
#undef BLACK
#endif

#define BLACK 0
#define WHITE 7

void clreol(void);
void gotoxy(int x,int y);
int  wherex(void);
int  wherey(void);
void video_end(void);
void video_init(void);
void video_update(void);
int  getkey(void);
int keypressed(void);
void cls(void);
void bputc(unsigned char c);
void bputs(char *s);
void clrwnd(int x1,int y1,int x2,int y2);
void scrollup(int x1,int y1,int x2,int y2,int lines);
void scrolldown(int x1,int y1,int x2,int y2,int lines);
int  getnum(int lo, int hi, int value);
int  bgets(char *s,int c);
void set_color(unsigned char attr);
unsigned get_color(void);
int  bprintf(char *s, ...);
void strins(char *l, char c, int x);
void strdel(char *l, int x);

#define TAB	0x0009		/* <Tab>	*/
#define PGUP    0x4900		/* <PgUp> 	*/
#define PGDN    0x5100		/* <PgDn>	*/
#define UP      0x4800		/* <up>		*/
#define DOWN    0x5000		/* <down>	*/
#define LEFT    0x4b00		/* <left>	*/
#define RIGHT   0x4d00		/* <right>	*/
#define WORDRT 	0x7400		/* <ctrl><right>*/
#define WORDLT 	0x7300		/* <ctrl><left>	*/
#define DELCHR  0x5300		/* <Del>	*/
#define DELLN	0x2000		/* <Alt><D>	*/
#define GOEOL	0x4f00		/* <End>	*/
#define GOBOL	0x4700		/* <Home>	*/
#define BKSPC   0x0008		/* <BkSpc>	*/
#define RUBOUT  0x007f
#define SAVE	0x1f00		/* <Alt><S>	*/
#define ABORT	0x001b		/* <Esc>	*/
#define INSERT  0x5200		/* <Ins>	*/
#define ENTER   0x000d		/* <enter>	*/
#define WRITE	0x1100		/* <Alt><W>	*/
#define IMPORT	0x1700		/* <Alt><I>	*/
#define ANCHOR	0x1e00		/* <Alt><A>	*/
#define CUT	0x2e00		/* <Alt><C>	*/
#define PASTE	0x1900		/* <Alt><P>	*/
#define FORMAT  0x2100          /* <Alt><F>     */
